[TOC]

#### Git的介绍

Git是世界上最流行的分布式版本管理系统

#### Git的起源

![Linus Torvalds (林纳斯·托瓦兹)](https://upload.wikimedia.org/wikipedia/commons/thumb/0/01/LinuxCon_Europe_Linus_Torvalds_03_%28cropped%29.jpg/220px-LinuxCon_Europe_Linus_Torvalds_03_%28cropped%29.jpg)



**Git是由Linux创始人Linus用C编写的一个分布式版本控制系统**



> Linus在1991年创建了开源的Linux，从此，Linux系统不断发展，已经成为最大的服务器系统软件了。
>
> Linus虽然创建了Linux，但Linux的壮大是靠全世界热心的志愿者参与的，这么多人在世界各地为Linux编写代码，那Linux的代码是如何管理的呢？
>
> 事实是，在2002年以前，世界各地的志愿者把源代码文件通过diff的方式发给Linus，然后由Linus本人通过手工方式合并代码！
>
> 你也许会想，为什么Linus不把Linux代码放到版本控制系统里呢？不是有CVS、SVN这些免费的版本控制系统吗？因为Linus坚定地反对CVS和SVN，这些集中式的版本控制系统不但速度慢，而且必须联网才能使用。有一些商用的版本控制系统，虽然比CVS、SVN好用，但那是付费的，和Linux的开源精神不符。
>
> 不过，到了2002年，Linux系统已经发展了十年了，代码库之大让Linus很难继续通过手工方式管理了，社区的弟兄们也对这种方式表达了强烈不满，于是Linus选择了一个商业的版本控制系统BitKeeper，BitKeeper的东家BitMover公司出于人道主义精神，授权Linux社区免费使用这个版本控制系统。
>
> 安定团结的大好局面在2005年就被打破了，原因是Linux社区牛人聚集，不免沾染了一些梁山好汉的江湖习气。开发Samba的Andrew试图破解BitKeeper的协议（这么干的其实也不只他一个），被BitMover公司发现了（监控工作做得不错！），于是BitMover公司怒了，要收回Linux社区的免费使用权。
>
> Linus可以向BitMover公司道个歉，保证以后严格管教弟兄们，嗯，这是不可能的。实际情况是这样的：
>
> Linus花了两周时间自己用C写了一个分布式版本控制系统，这就是Git！一个月之内，Linux系统的源码已经由Git管理了！牛是怎么定义的呢？大家可以体会一下。
>
> Git迅速成为最流行的分布式版本控制系统，尤其是2008年，GitHub网站上线了，它为开源项目免费提供Git存储，无数开源项目开始迁移至GitHub，包括jQuery，PHP，Ruby等等。
>
> 历史就是这么偶然，如果不是当年BitMover公司威胁Linux社区，可能现在我们就没有免费而超级好用的Git了。



#### 集中式版本控制系统和分布式版本控制系统的区别

**集中式版本控制系统的特点:**

版本库存在中央服务器，而干活的时候，用的都是自己的电脑，所以要先从中央服务器取得最新的版本，然后开始干活，干完活了，再把自己的活推送给中央服务器。

集中式版本控制系统的缺点:

1. 必须联网才能工作，如果在局域网内还好，带宽够大，速度够快，可如果在互联网上，遇到网速慢的话，可能提交一个10M的文件就需要5分钟

2. 中央服务器如果版本库丢失,历史记录将再也找不回来

**分布式版本控制系统的特点**:

分布式版本控制系统根本没有“中央服务器”，每个人的电脑上都是一个完整的版本库，这样，你工作的时候，就不需要联网了，因为版本库就在你自己的电脑上。

在实际使用分布式版本控制系统的时候，通常也有一台充当“中央服务器”的电脑，但这个服务器的作用仅仅是用来方便“交换”大家的修改，没有它大家也一样干活，只是交换修改不方便而已。

**两者区别:**

和集中式版本控制系统相比，分布式版本控制系统的安全性要高很多，因为每个人电脑里都有完整的版本库，某一个人的电脑坏掉了不要紧，随便从其他人那里复制一个就可以了。而集中式版本控制系统的中央服务器要是出了问题，所有人都没法干活了。

Git的优势不单是不必联网这么简单，Git有极其强大的分支管理，把SVN等远远抛在了后面。



#### Git的使用

1. 安装  <https://git-scm.com>

2. 设置本机Git账号和邮箱

   1. ```git config --global user.name "Your Name"```
   2. ```git config --global user.email "email@example.com"```

3. 创建版本库

   1. 在非中文目录下创建版本库 (会有一个隐藏的.git文件夹)    ```git init```

   2. 新建文件

   3. 添加到仓库(暂存区)   ```git add 文件名```

   4. 提交到仓库(版本库)  ```git commit 文件名 -m '此处输入提交说明'```

      > 为什么Git添加文件需要`add`，`commit`一共两步呢？因为`commit`可以一次提交很多文件，所以你可以多次`add`不同的文件，比如：
      >
      > ```
      > git add file1.txt
      > git add file2.txt file3.txt
      > git commit -m "add 3 files."修改文件,查看状态  ```git status```
      > ```

4. 版本回退

   1. 查看提交历史,版本id   ```git log  [--oneline]```

   2. 版本回退  ```git reset 版本id```

      > 如果工作区在回退之前修改了文件,在回退后修改的文件内容会保留,如果想不保留修改的内容,直接回退到某个版本  需要加参数 --hard  ```git reset --hard 版本id```
      >
      > 回退后log记录会清除
      >
      > 版本ID可以只写前几位,会自动匹配
      >
      > HEAD指向当前版本,HEAD^指向HEAD的上一个版本,HEAD^^指向上两个版本,HEAD~20指向上20个版本
      >
      > 同理 在回退的时候 版本id也可以写成HEAD  ```git reset HEAD^```   // 回退到上一个版本
      >
      > 回退的速度很快,因为git只是向将HEAD的指针指向了另一个版本,顺带更新了工作区而已
      >
      > 如果后悔了,再想恢复到没有回退前的版本,必须找到以前的版本id,此时通过git log命令已经找不到了,但是Git提供了一个命令`git reflog`用来记录你的每一次命令

5. 撤销修改

   1. 撤销工作区的修改 ```git checkout -- file```

      > git checkout 丢弃工作区的修改,分两种情况
      >
      > 1. 在工作区内容修改后,没有添加到暂存区,此时撤销修改会回到和上一次提交一模一样的状态
      > 2. 在工作区内容已经提交到暂存区后,又做了修改,此时撤销修改会回到和暂存区一模一样的状态

   2. 撤销已经提交到暂存区的修改  ```git reset HEAD file```

      > git reset可以进行版本回退,也可以进行回退暂存区的修改,执行完毕后暂存区的内容将重新回到工作区

6. 删除文件

   > 1. 删除文件,一般直接右键删除,然后执行前面提到的```git add file```和```git commit -m '提交信息'```来提交到版本库
   > 2. 也可以使用```git rm file```和执行```git commit -m '提交信息'``` (git rm操作会自动add到暂存区)
   > 3. 如果误删了文件要回复,执行前面提到的撤销修改命令



#### 分支管理

分支的作用: 

假设你准备开发一个新功能，但是需要两周才能完成，第一周你写了50%的代码，如果立刻提交，由于代码还没写完，不完整的代码库会导致别人不能干活了。如果等代码全部写完再一次提交，又存在丢失每天进度的巨大风险。

有了分支，就不用怕了。你创建了一个属于你自己的分支，别人看不到，还继续在原来的分支上正常工作，而你在自己的分支上干活，想提交就提交，直到开发完毕后，再一次性合并到原来的分支上，这样，既安全，又不影响别人工作。

如果分支和主分支上的内容在合并时发生冲突,需要手动解决冲突	



指令:

创建分支: ```git branch name```

切换分支: ```git checkout name```

查看分支: ```git branch```

合并某分支到当前分支:

​	 ```git merge name```(覆盖后log没有记录) 

​	 ```git merge --no-ff -m "messsage" name```(覆盖后log会记录当前操作)

删除分支: ```git branch -d name```

##### ​bug分支

假设你正在dev分支上开发新功能,此时主分支发现了一个bug,你需要尽快解决,但是你dev分支的功能还只开发了一半,预计完成还需要一周时间,还不能提交,怎么办呢?

1. 先把改动储藏起来```git stash```   (查看储藏列表```git stash list```)
2. 切换回主分支
3. 创建bug分支并且在bug分支上修复bug
4. 切换回主分支,并且合并bug分支
5. 删除bug分支
6. 重新切换到dev分支
7. 恢复改动 ```git stash pop``` 恢复完毕储藏列表会自动删除



#### 多人协作

1. 获取版本库```git clone 远程地址url``` ,当你从远程仓库克隆时，实际上Git自动把本地的`master`分支和远程的`master`分支对应起来了，并且，远程仓库的默认名称是`origin`
2. 推送当前分支的提交到远程仓库 ```git push origin master```
3. 拉取远程仓库代码  ```git pull origin master```
4. 查看远程库信息```git remote -v```



> <https://www.liaoxuefeng.com/wiki/0013739516305929606dd18361248578c67b8067c8c017b000/00137628548491051ccfaef0ccb470894c858999603fedf000>

By <https://github.com/protogenesis>











